// Copyright (C) 2006-2009 Kent-Andre Mardal and Simula Research Laboratory
//
// This file is part of SyFi.
//
// SyFi is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// SyFi is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SyFi. If not, see <http://www.gnu.org/licenses/>.

#ifndef ELEMENTCOMPUTATIONS_IS_INCLUDED
#define ELEMENTCOMPUTATIONS_IS_INCLUDED

#include "FE.h"
#include "Dof.h"

namespace SyFi
{

	void usage(FE& fe);
	void usage(FE& v_fe, FE& p_fe);

	void compute_Poisson_element_matrix(FE& fe, Dof& dof, std::map<std::pair<unsigned int,unsigned int>, GiNaC::ex>& A);
	void compute_Stokes_element_matrix(FE& v_fe, FE& p_fe, Dof& dof, std::map<std::pair<unsigned int,unsigned int>, GiNaC::ex>& A);
	void compute_mixed_Poisson_element_matrix(FE& v_fe, FE& p_fe, Dof& dof, std::map<std::pair<unsigned int,unsigned int>, GiNaC::ex>& A);

}
#endif
